#include <iostream>


using namespace std;


class Array1D
{
private:
	int* arr1;
	int len1;
public:
	Array1D(int n = 0) : len1(n)
	{
		arr1 = new int[n];
		for(int i=0; i<n; i++)
		{
			printf("[1]            %x\n", &arr1[i]);
		}
	}
	int& operator[](int index)
	{
		if (index < 0 || index >= len1)
		{
			cout << "Out of index range" << endl;
			exit(0);
		}
		return *(&arr1[index]);
	}
	int Getlen()
	{
		return len1;
	}
	~Array1D()
	{
		cout << "Array1" << endl;
		delete[]arr1;
	}
};


class Array2D
{
private:
    Array1D** arr2;
    int len;

public:
    Array2D(int n1, int n2) :len(n1)
    {
        arr2 = new Array1D * [n1];
		printf("[2]   %x\n", arr2);
        for (int i = 0; i < n1; i++)
        {
            arr2[i] = new Array1D(n2);    
			printf("[2]   %x\n", arr2[i]);
		}
    }

    Array1D& operator[](int index)
    {
        if (index < 0 || index >= len)
        {
            cout << "Out of index range" << endl;
            exit(0);
        }
        return *arr2[ index ];
    }

    int Getlen()
    {
        return len;
    }

    ~Array2D()
    {
        cout << "Array2" << endl;

		for (int i=0; i<len; i++)
			delete arr2[i];

		delete[]arr2;
    }
 
};


int MAX_X = 4;
int MAX_Y = 2;

int main(int argc, char** argv) 
{

	Array2D arr(MAX_X, MAX_Y);
 
	for (int k = 0; k < MAX_X; k++)
	{
		for (int p = 0; p < MAX_Y; p++)
		{
			arr[k][p] = 1;
			printf("main   %x %x\n", &arr[k][p], &arr[k]);
		}
	}
	cout << arr[1][1] << endl;

	return 0;
}


#if 0

[2]   3d3f08
[1]            3d3a48
[1]            3d3a4c
[1]            3d3a50
[1]            3d3a54
[2]   3d3f18
[1]            3d3a98
[1]            3d3a9c
[1]            3d3aa0
[1]            3d3aa4
[2]   3d3f28
main   3d3a48 3d3f18
main   3d3a4c 3d3f18
main   3d3a50 3d3f18
main   3d3a54 3d3f18
main   3d3a98 3d3f28
main   3d3a9c 3d3f28
main   3d3aa0 3d3f28
main   3d3aa4 3d3f28
1
Array2
Array1
Array1

--------------------------------
Process exited after 0.5847 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . .




[2]   3d3a48
[1]            3d3f18
[1]            3d3f1c
[2]   3d3f08
[1]            3d3f38
[1]            3d3f3c
[2]   3d3f28
[1]            3d3f58
[1]            3d3f5c
[2]   3d3f48
[1]            3d3f78
[1]            3d3f7c
[2]   3d3f68
main   3d3f18 3d3f08
main   3d3f1c 3d3f08
main   3d3f38 3d3f28
main   3d3f3c 3d3f28
main   3d3f58 3d3f48
main   3d3f5c 3d3f48
main   3d3f78 3d3f68
main   3d3f7c 3d3f68
1
Array2
Array1
Array1
Array1
Array1

--------------------------------
Process exited after 0.2234 seconds with return value 0
Ϸ ƹ Ű ʽÿ . . .



#endif

